diff -ur mpd-5.6/src/pppoe.c mpd-5.6-lutz/src/pppoe.c
--- mpd-5.6/src/pppoe.c	2011-12-21 15:58:49.000000000 +0100
+++ mpd-5.6-lutz/src/pppoe.c	2013-04-24 11:58:30.000000000 +0200
@@ -257,6 +257,7 @@
 	snprintf(session_hook, sizeof(session_hook), "mpd%d-%d", 
 	    gPid, l->id);
 	
+   	MUTEX_LOCK(gNgMutex);
 	if (pe->incoming == 1) {
 		Log(LG_PHYS2, ("[%s] PppoeOpen() on incoming call", l->name));
 
@@ -267,10 +268,12 @@
 		/* Connect ng_tee(4) node to the ng_ppp(4) node. */
 		memset(&cn, 0, sizeof(cn));
 		if (!PhysGetUpperHook(l, cn.path, cn.peerhook)) {
-		    Log(LG_PHYS, ("[%s] PPPoE: can't get upper hook", l->name));
+		    Log(LG_ERR|LG_PHYS, ("[%s] PPPoE: can't get upper hook", l->name));
 		    goto fail3;
 		}
 		snprintf(cn.ourhook, sizeof(cn.ourhook), "right");
+	   
+	   
 		if (NgSendMsg(pe->PIf->csock, path, NGM_GENERIC_COOKIE, NGM_CONNECT, 
 		    &cn, sizeof(cn)) < 0) {
 			Perror("[%s] PPPoE: can't connect \"%s\"->\"%s\" and \"%s\"->\"%s\"",
@@ -289,12 +292,14 @@
 		    l->state = PHYS_STATE_UP;
 		    PhysUp(l);
 		}
+	   	MUTEX_UNLOCK(gNgMutex);
 		return;
 	}
 
+   	MUTEX_UNLOCK(gNgMutex);
 	/* Sanity check. */
 	if (l->state != PHYS_STATE_DOWN) {
-		Log(LG_PHYS, ("[%s] PPPoE allready active", l->name));
+		Log(LG_ERR|LG_PHYS, ("[%s] PPPoE allready active", l->name));
 		return;
 	};
 
@@ -307,12 +312,13 @@
 	    goto fail;
 	}
 
+   	MUTEX_LOCK(gNgMutex);
 	/* Connect our ng_ppp(4) node link hook to the ng_pppoe(4) node. */
 	strlcpy(cn.ourhook, session_hook, sizeof(cn.ourhook));
 	snprintf(path, sizeof(path), "[%x]:", pe->PIf->node_id);
 
 	if (!PhysGetUpperHook(l, cn.path, cn.peerhook)) {
-	    Log(LG_PHYS, ("[%s] PPPoE: can't get upper hook", l->name));
+	    Log(LG_ERR|LG_PHYS, ("[%s] PPPoE: can't get upper hook", l->name));
 	    goto fail2;
 	}
 	
@@ -346,12 +352,14 @@
 	strlcpy(pe->real_session, pe->session, sizeof(pe->real_session));
 	pe->agent_cid[0] = 0;
 	pe->agent_rid[0] = 0;
+   	MUTEX_UNLOCK(gNgMutex);
 	return;
 
 fail3:
 	snprintf(path, sizeof(path), "[%x]:", pe->PIf->node_id);
 fail2:
 	NgFuncDisconnect(pe->PIf->csock, l->name, path, session_hook);
+   	MUTEX_UNLOCK(gNgMutex);
 fail:	
 	PhysDown(l, STR_ERROR, NULL);
 	return;
@@ -416,6 +424,7 @@
 	if (l->state == PHYS_STATE_DOWN)
 		return;
 
+   	MUTEX_LOCK(gNgMutex);
 	snprintf(path, sizeof(path), "[%x]:", pi->PIf->node_id);
 	snprintf(session_hook, sizeof(session_hook), "mpd%d-%d",
 	    gPid, l->id);
@@ -428,6 +437,7 @@
 	pi->real_session[0] = 0;
 	pi->agent_cid[0] = 0;
 	pi->agent_rid[0] = 0;
+   	MUTEX_UNLOCK(gNgMutex);
 }
 
 /*
@@ -448,11 +458,15 @@
 	
 	struct PppoeIf  *PIf = (struct PppoeIf*)arg;
 	
+   	MUTEX_LOCK(gNgMutex);
 	/* Read control message. */
 	if (NgRecvMsg(PIf->csock, &u.resp, sizeof(u), path) < 0) {
 		Perror("PPPoE: error reading message from \"%s\"", path);
+	   	MUTEX_UNLOCK(gNgMutex);
 		return;
 	}
+   	MUTEX_UNLOCK(gNgMutex);
+
 	if (u.resp.header.typecookie != NGM_PPPOE_COOKIE) {
 		Log(LG_ERR, ("PPPoE: rec'd cookie %lu from \"%s\"",
 		    (u_long)u.resp.header.typecookie, path));
@@ -683,9 +697,11 @@
 		return (0);
 	}
 
+   	MUTEX_LOCK(gNgMutex);
 	/* Create a new netgraph node */
 	if (NgMkSockNode(NULL, &PIf->csock, &PIf->dsock) < 0) {
 		Perror("[%s] PPPoE: can't create ctrl socket", iface);
+	   	MUTEX_UNLOCK(gNgMutex);
 		return(0);
 	}
 	(void)fcntl(PIf->csock, F_SETFD, 1);
@@ -702,6 +718,7 @@
 			    iface);
 			close(PIf->csock);
 			close(PIf->dsock);
+		   	MUTEX_UNLOCK(gNgMutex);
 			return (0);
 		}
 
@@ -712,6 +729,7 @@
 			    iface);
 			close(PIf->csock);
 			close(PIf->dsock);
+		   	MUTEX_UNLOCK(gNgMutex);
 			return (0);
 		}
 
@@ -728,6 +746,7 @@
 			Perror("PPPoE: Cannot load ng_ether");
 			close(PIf->csock);
 			close(PIf->dsock);
+		   	MUTEX_UNLOCK(gNgMutex);
 			assert (0);
 		}
 		gNgEtherLoaded = TRUE;
@@ -743,6 +762,7 @@
 		Perror("[%s] Cannot send a netgraph message: %s", iface, path);
 		close(PIf->csock);
 		close(PIf->dsock);
+	   	MUTEX_UNLOCK(gNgMutex);
 		return (0);
 	}
 
@@ -752,6 +772,7 @@
 		Perror("[%s] Cannot get netgraph response", iface);
 		close(PIf->csock);
 		close(PIf->dsock);
+	   	MUTEX_UNLOCK(gNgMutex);
 		return (0);
 	}
 
@@ -766,6 +787,7 @@
 		    iface, ninfo->type, path));
 		close(PIf->csock);
 		close(PIf->dsock);
+	   	MUTEX_UNLOCK(gNgMutex);
 		return (0);
 	}
 
@@ -789,6 +811,7 @@
 			    path, nlink->nodeinfo.type));
 			close(PIf->csock);
 			close(PIf->dsock);
+		   	MUTEX_UNLOCK(gNgMutex);
 			return (0);
 		}
 		PIf->node_id = nlink->nodeinfo.id;
@@ -810,6 +833,7 @@
 			    iface, NG_PPPOE_NODE_TYPE, path, hook);
 			close(PIf->csock);
 			close(PIf->dsock);
+		   	MUTEX_UNLOCK(gNgMutex);
 			return (0);
 		}
 
@@ -819,10 +843,12 @@
 			Perror("[%s] Cannot get pppoe node id", iface);
 			close(PIf->csock);
 			close(PIf->dsock);
+		   	MUTEX_UNLOCK(gNgMutex);
 			return (0);
 		};
 	};
 
+   	MUTEX_UNLOCK(gNgMutex);
 	/* Register an event listening to the control and data sockets. */
 	EventRegister(&(PIf->ctrlEvent), EVENT_READ, PIf->csock,
 	    EVENT_RECURRING, PppoeCtrlReadEvent, PIf);
@@ -922,14 +948,18 @@
 	} u;
 	struct ngpppoe_init_data *const idata = &u.poeid;
 
+   	MUTEX_LOCK(gNgMutex);
 	switch (sz = NgRecvData(PIf->dsock, response, sizeof(response), rhook)) {
           case -1:
 	    Log(LG_ERR, ("NgRecvData: %d", sz));
+	    MUTEX_UNLOCK(gNgMutex);
             return;
           case 0:
             Log(LG_ERR, ("NgRecvData: socket closed"));
+	    MUTEX_UNLOCK(gNgMutex);
             return;
         }
+   	MUTEX_UNLOCK(gNgMutex);
 
 	if (strncmp(rhook, "listen-", 7)) {
 		Log(LG_ERR, ("PPPoE: data from unknown hook \"%s\"", rhook));
@@ -1015,12 +1045,13 @@
 	    l = LinkInst(l, NULL, 0, 0);
 
 	if (l == NULL) {
-		Log(LG_PHYS, ("No free PPPoE link with requested parameters "
+		Log(LG_ERR|LG_PHYS, ("No free PPPoE link with requested parameters "
 		    "was found"));
 		return;
 	}
 	pi = (PppoeInfo)l->info;
 	
+   	MUTEX_LOCK(gNgMutex);
 	Log(LG_PHYS, ("[%s] Accepting PPPoE connection", l->name));
 
 	/* Path to the ng_pppoe */
@@ -1113,6 +1144,7 @@
 
 	Log(LG_PHYS2, ("[%s] PPPoE response sent", l->name));
 
+   	MUTEX_UNLOCK(gNgMutex);
 	/* Set a timer to limit connection time. */
 	TimerInit(&pi->connectTimer, "PPPoE-connect",
 	    PPPOE_CONNECT_TIMEOUT * SECONDS, PppoeConnectTimeout, l);
@@ -1127,6 +1159,7 @@
 	};
 
 close_socket:
+   	MUTEX_UNLOCK(gNgMutex);
 	Log(LG_PHYS, ("[%s] PPPoE connection not accepted due to error",
 	    l->name));
 
@@ -1247,6 +1280,7 @@
 
 	snprintf(path, sizeof(path), "[%x]:", PIf->node_id);
 	
+   	MUTEX_LOCK(gNgMutex);
 	/* Connect our socket node link hook to the ng_pppoe(4) node. */
 	memset(&cn, 0, sizeof(cn));
 	strcpy(cn.path, path);
@@ -1258,6 +1292,7 @@
 		Log(LG_ERR, ("PPPoE: Can't connect \"%s\"->\"%s\" and \"%s\"->\"%s\": %s",
 		    ".:", cn.ourhook, cn.path, cn.peerhook,
 		    strerror(errno)));
+	   	MUTEX_UNLOCK(gNgMutex);
 		return(0);
 	}
 
@@ -1271,12 +1306,14 @@
 	    idata, sizeof(*idata) + idata->data_len) < 0) {
 		Perror("PPPoE: Can't send NGM_PPPOE_LISTEN to %s hook %s",
 		     path, idata->hook);
+	   	MUTEX_UNLOCK(gNgMutex);
 		return (0);
 	}
 
 	Log(LG_PHYS, ("PPPoE: waiting for connection on %s, service \"%s\"",
 		PIf->ifnodepath, idata->data));
 	    
+   	MUTEX_UNLOCK(gNgMutex);
 	return (1);
 }
 
@@ -1291,6 +1328,7 @@
 	if (!pi->list)
 	    return(1);	/* Do this only once */
 
+   	MUTEX_LOCK(gNgMutex);
 	pi->list->refs--;
 	
 	if (pi->list->refs == 0) {
@@ -1307,6 +1345,7 @@
 	}
 	    
 	pi->list = NULL;
+   	MUTEX_UNLOCK(gNgMutex);
 	return (1);
 }
 
diff -ur mpd-5.6/src/pptp.c mpd-5.6-lutz/src/pptp.c
--- mpd-5.6/src/pptp.c	2011-12-21 15:58:49.000000000 +0100
+++ mpd-5.6-lutz/src/pptp.c	2013-04-24 11:55:57.000000000 +0200
@@ -294,7 +294,7 @@
     switch (l->state) {
 	case PHYS_STATE_DOWN:
     	    if (PptpOriginate(l) < 0) {
-		Log(LG_PHYS, ("[%s] PPTP call failed", l->name));
+		Log(LG_ERR|LG_PHYS, ("[%s] PPTP call failed", l->name));
 		PhysDown(l, STR_ERROR, NULL);
 		return;
     	    }
@@ -450,8 +450,10 @@
 	if (pptp->tun == NULL)
 		return;
 
+   	MUTEX_LOCK(gNgMutex);
 	/* Get a temporary netgraph socket node */
 	if (NgMkSockNode(NULL, &csock, NULL) == -1) {
+	   	MUTEX_UNLOCK(gNgMutex);
 		Perror("PPTP: NgMkSockNode");
 		return;
 	}
@@ -472,6 +474,7 @@
 	}
 	
 	close(csock);
+   	MUTEX_UNLOCK(gNgMutex);
 	
 	pptp->tun = NULL;
 }
@@ -838,13 +841,15 @@
     u_addrtosockaddr(&u_peer_addr, 0, &peer_addr);
 
     if (!PhysGetUpperHook(l, path, hook)) {
-        Log(LG_PHYS, ("[%s] PPTP: can't get upper hook", l->name));
+        Log(LG_ERR|LG_PHYS, ("[%s] PPTP: can't get upper hook", l->name));
         return(-1);
     }
     
+    MUTEX_LOCK(gNgMutex);
     /* Get a temporary netgraph socket node */
     if (NgMkSockNode(NULL, &csock, NULL) == -1) {
 	Perror("PPTP: NgMkSockNode");
+   	MUTEX_UNLOCK(gNgMutex);
 	return(-1);
     }
 
@@ -866,6 +871,7 @@
 	    Perror("[%s] PPTP: ghash_put", l->name);
 	    Freee(tun);
 	    close(csock);
+	    MUTEX_UNLOCK(gNgMutex);
 	    return(-1);
 	}
     
@@ -883,6 +889,7 @@
 	    ghash_remove(gPptpTuns, tun);
 	    Freee(tun);
 	    close(csock);
+	    MUTEX_UNLOCK(gNgMutex);
 	    return(-1);
 	}
 
@@ -892,6 +899,7 @@
 	    ghash_remove(gPptpTuns, tun);
 	    Freee(tun);
 	    close(csock);
+	    MUTEX_UNLOCK(gNgMutex);
 	    return(-1);
 	};
 	tun->refs++;
@@ -910,6 +918,7 @@
 	  NGM_MKPEER, &mkp, sizeof(mkp)) < 0) {
 	    Perror("[%s] PPTP: can't attach %s node", l->name, NG_KSOCKET_NODE_TYPE);
 	    close(csock);
+	    MUTEX_UNLOCK(gNgMutex);
 	    return(-1);
 	}
 	snprintf(ksockpath, sizeof(ksockpath),
@@ -930,6 +939,7 @@
           NGM_KSOCKET_BIND, &self_addr, self_addr.ss_len) < 0) {
 	    Perror("[%s] PPTP: can't bind() %s node", l->name, NG_KSOCKET_NODE_TYPE);
 	    close(csock);
+	    MUTEX_UNLOCK(gNgMutex);
 	    return(-1);
 	}
 
@@ -940,6 +950,7 @@
 	    Perror("[%s] PPTP: can't connect() %s node",
     	        l->name, NG_KSOCKET_NODE_TYPE);
 	    close(csock);
+	    MUTEX_UNLOCK(gNgMutex);
     	    return(-1);
         }
 #ifdef	NG_PPTPGRE_HOOK_SESSION_F
@@ -953,6 +964,7 @@
 	    Perror("[%s] PPTP: can't connect to %s node",
     		l->name, NG_PPTPGRE_NODE_TYPE);
 	    close(csock);
+	    MUTEX_UNLOCK(gNgMutex);
 	    return(-1);
 	}
 	tun->refs++;
@@ -972,10 +984,12 @@
       NGM_PPTPGRE_SET_CONFIG, &gc, sizeof(gc)) < 0) {
 	Perror("[%s] PPTP: can't config %s node", l->name, NG_PPTPGRE_NODE_TYPE);
 	close(csock);
+   	MUTEX_UNLOCK(gNgMutex);
 	return(-1);
     }
   
     close(csock);
+    MUTEX_UNLOCK(gNgMutex);
 
     return(0);
 }
@@ -1087,7 +1101,7 @@
 
     /* If no link is suitable, can't take the call */
     if (l == NULL) {
-	Log(LG_PHYS, ("No free PPTP link with requested parameters "
+	Log(LG_ERR|LG_PHYS, ("No free PPTP link with requested parameters "
 	    "was found"));
 	return(linfo);
     }
diff -ur mpd-5.6/src/pptp_ctrl.c mpd-5.6-lutz/src/pptp_ctrl.c
--- mpd-5.6/src/pptp_ctrl.c	2011-12-21 15:58:49.000000000 +0100
+++ mpd-5.6-lutz/src/pptp_ctrl.c	2013-04-24 11:54:34.000000000 +0200
@@ -695,7 +695,7 @@
   /* Find/create control block */
   if ((c = PptpCtrlGetCtrl(TRUE, locip, ip, port,
       ebuf, sizeof(ebuf))) == NULL) {
-    Log(LG_PHYS2, ("%s", ebuf));
+    Log(LG_ERR|LG_PHYS2, ("%s", ebuf));
     return;
   }
 
@@ -826,7 +826,7 @@
     /* Initialize a new control block */
     if ((c = PptpCtrlGetCtrl(FALSE, &self_addr, &peer_addr, peer_port,
     	    ebuf, sizeof(ebuf))) == NULL) {
-	Log(LG_PHYS2, ("PPTP: Control connection failed: %s", ebuf));
+	Log(LG_ERR|LG_PHYS2, ("PPTP: Control connection failed: %s", ebuf));
 	close(sock);
 	return;
     }
@@ -856,7 +856,7 @@
 
   /* Check whether the connection was successful or not */
   if (getpeername(c->csock, (struct sockaddr *) &addr, &addrLen) < 0) {
-    Log(LG_PHYS2, ("pptp%d: connection to %s %d failed",
+    Log(LG_ERR|LG_PHYS2, ("pptp%d: connection to %s %d failed",
       c->id, u_addrtoa(&c->peer_addr,buf,sizeof(buf)), c->peer_port));
     PptpCtrlKillCtrl(c);
     return;
@@ -901,7 +901,7 @@
   /* Get local IP address */
   addrLen = sizeof(self);
   if (getsockname(c->csock, (struct sockaddr *) &self, &addrLen) < 0) {
-    Log(LG_PHYS2, ("pptp%d: %s: %s", c->id, "getsockname", strerror(errno)));
+    Log(LG_ERR|LG_PHYS2, ("pptp%d: %s: %s", c->id, "getsockname", strerror(errno)));
 abort:
     PptpCtrlKillCtrl(c);
     return;
@@ -911,7 +911,7 @@
   /* Get remote IP address */
   addrLen = sizeof(peer);
   if (getpeername(c->csock, (struct sockaddr *) &peer, &addrLen) < 0) {
-    Log(LG_PHYS2, ("pptp%d: %s: %s", c->id, "getpeername", strerror(errno)));
+    Log(LG_ERR|LG_PHYS2, ("pptp%d: %s: %s", c->id, "getpeername", strerror(errno)));
     goto abort;
   }
   sockaddrtou_addr(&peer, &c->peer_addr, &c->peer_port);
@@ -923,7 +923,7 @@
   /* Turn of Nagle algorithm on the TCP socket, since we are going to
      be writing complete control frames one at a time */
   if (setsockopt(c->csock, IPPROTO_TCP, TCP_NODELAY, &one, sizeof(one)) < 0)
-    Log(LG_PHYS2, ("pptp%d: %s: %s", c->id, "setsockopt", strerror(errno)));
+    Log(LG_ERR|LG_PHYS2, ("pptp%d: %s: %s", c->id, "setsockopt", strerror(errno)));
 
   /* Register for events on control and data sockets */
   EventRegister(&c->ctrlEvent, EVENT_READ,
@@ -971,9 +971,9 @@
     if (nread < 0) {
       if (errno == EAGAIN)
 	return;
-      Log(LG_PHYS2, ("pptp%d: %s: %s", c->id, "read", strerror(errno)));
+      Log(LG_ERR|LG_PHYS2, ("pptp%d: %s: %s", c->id, "read", strerror(errno)));
     } else
-      Log(LG_PHYS2, ("pptp%d: ctrl connection closed by peer", c->id));
+      Log(LG_ERR|LG_PHYS2, ("pptp%d: ctrl connection closed by peer", c->id));
     goto abort;
   }
   LogDumpBuf(LG_FRAME, c->frame.buf + c->flen, nread,
@@ -988,15 +988,15 @@
     Log(LG_FRAME, ("pptp%d: got hdr", c->id));
     PptpCtrlDump(LG_FRAME, 0, hdr);
     if (hdr->msgType != PPTP_CTRL_MSG_TYPE) {
-      Log(LG_PHYS2, ("pptp%d: invalid msg type %d", c->id, hdr->msgType));
+      Log(LG_ERR|LG_PHYS2, ("pptp%d: invalid msg type %d", c->id, hdr->msgType));
       goto abort;
     }
     if (hdr->magic != PPTP_MAGIC) {
-      Log(LG_PHYS2, ("pptp%d: invalid magic %x", c->id, hdr->type));
+      Log(LG_ERR|LG_PHYS2, ("pptp%d: invalid magic %x", c->id, hdr->type));
       goto abort;
     }
     if (!PPTP_VALID_CTRL_TYPE(hdr->type)) {
-      Log(LG_PHYS2, ("pptp%d: invalid ctrl type %d", c->id, hdr->type));
+      Log(LG_ERR|LG_PHYS2, ("pptp%d: invalid ctrl type %d", c->id, hdr->type));
       goto abort;
     }
     if (hdr->resv0 != 0) {
@@ -1006,7 +1006,7 @@
 #endif
     }
     if (hdr->length != sizeof(*hdr) + gPptpMsgInfo[hdr->type].length) {
-      Log(LG_PHYS2, ("pptp%d: invalid length %d for type %d",
+      Log(LG_ERR|LG_PHYS2, ("pptp%d: invalid length %d for type %d",
 	c->id, hdr->length, hdr->type));
 abort:
       PptpCtrlKillCtrl(c);
@@ -1082,13 +1082,13 @@
 
   /* Check for invalid message and call or control state combinations */
   if (!ch && ((1 << c->state) & mi->states) == 0) {
-    Log(LG_PHYS2, ("pptp%d: got %s in state %s",
+    Log(LG_ERR|LG_PHYS2, ("pptp%d: got %s in state %s",
       c->id, gPptpMsgInfo[type].name, gPptpCtrlStates[c->state]));
     PptpCtrlKillCtrl(c);
     return;
   }
   if (ch && ((1 << ch->state) & mi->states) == 0) {
-    Log(LG_PHYS2, ("pptp%d-%d: got %s in state %s",
+    Log(LG_ERR|LG_PHYS2, ("pptp%d-%d: got %s in state %s",
       c->id, ch->id, gPptpMsgInfo[type].name, gPptpChanStates[ch->state]));
     PptpCtrlKillCtrl(c);
     return;
@@ -1139,9 +1139,9 @@
   /* Send it; if TCP buffer is full, we abort the connection */
   if ((nwrote = write(c->csock, frame.buf, totlen)) != totlen) {
     if (nwrote < 0)
-      Log(LG_PHYS2, ("pptp%d: %s: %s", c->id, "write", strerror(errno)));
+      Log(LG_ERR|LG_PHYS2, ("pptp%d: %s: %s", c->id, "write", strerror(errno)));
     else
-      Log(LG_PHYS2, ("pptp%d: only wrote %d/%d", c->id, nwrote, totlen));
+      Log(LG_ERR|LG_PHYS2, ("pptp%d: only wrote %d/%d", c->id, nwrote, totlen));
     PptpCtrlKillCtrl(c);
     return -1;
   }
@@ -2020,7 +2020,7 @@
 
     /* Check protocol version */
     if (req->vers != PPTP_PROTO_VERS) {
-	Log(LG_PHYS2, ("pptp%d: incompatible protocol 0x%04x", c->id, req->vers));
+	Log(LG_ERR|LG_PHYS2, ("pptp%d: incompatible protocol 0x%04x", c->id, req->vers));
 	reply.result = PPTP_SCCR_RESL_VERS;
 	if (PptpCtrlWriteMsg(c, PPTP_StartCtrlConnReply, &reply) == -1)
 	    return;
@@ -2045,7 +2045,7 @@
 
     /* Is peer happy? */
     if (rep->result != 0 && rep->result != PPTP_SCCR_RESL_OK) {
-	Log(LG_PHYS2, ("pptp%d: my %s failed, result=%s err=%s",
+	Log(LG_ERR|LG_PHYS2, ("pptp%d: my %s failed, result=%s err=%s",
     	    c->id, gPptpMsgInfo[PPTP_StartCtrlConnRequest].name,
     	    PPTP_SCCR_RESL_CODE(rep->result), PPTP_ERROR_CODE(rep->err)));
 	PptpCtrlKillCtrl(c);
@@ -2056,7 +2056,7 @@
     if (rep->vers != PPTP_PROTO_VERS) {
 	struct pptpStopCtrlConnRequest	req;
 
-	Log(LG_PHYS2, ("pptp%d: incompatible protocol 0x%04x", c->id, rep->vers));
+	Log(LG_ERR|LG_PHYS2, ("pptp%d: incompatible protocol 0x%04x", c->id, rep->vers));
 	memset(&req, 0, sizeof(req));
 	req.reason = PPTP_SCCR_REAS_PROTO;
 	PptpCtrlNewCtrlState(c, PPTP_CTRL_ST_WAIT_STOP_REPLY);
@@ -2124,11 +2124,11 @@
 PptpEchoReply(PptpCtrl c, struct pptpEchoReply *rep)
 {
   if (rep->result != PPTP_ECHO_RESL_OK) {
-    Log(LG_PHYS2, ("pptp%d: echo reply failed: res=%s err=%s",
+    Log(LG_ERR|LG_PHYS2, ("pptp%d: echo reply failed: res=%s err=%s",
       c->id, PPTP_ECHO_RESL_CODE(rep->result), PPTP_ERROR_CODE(rep->err)));
     PptpCtrlKillCtrl(c);
   } else if (rep->id != c->echoId) {
-    Log(LG_PHYS2, ("pptp%d: bogus echo reply: %u != %u",
+    Log(LG_ERR|LG_PHYS2, ("pptp%d: bogus echo reply: %u != %u",
       c->id, rep->id, c->echoId));
     PptpCtrlKillCtrl(c);
   }
@@ -2162,7 +2162,7 @@
   if ((ch = PptpCtrlGetChan(c, PPTP_CHAN_ST_WAIT_ANSWER, FALSE, FALSE,
       req->bearType, req->frameType, req->minBps, req->maxBps,
       PPTP_STR_INTERNAL_CALLING, calledNum, subAddress)) == NULL) {
-    Log(LG_PHYS2, ("pptp%d: no free channels for outgoing call", c->id));
+    Log(LG_ERR|LG_PHYS2, ("pptp%d: no free channels for outgoing call", c->id));
     goto chFail;
   }
 
@@ -2210,7 +2210,7 @@
       "pptp%d-%d: outgoing call failed: res=%s err=%s",
       c->id, ch->id, PPTP_OCR_RESL_CODE(reply->result),
       PPTP_ERROR_CODE(reply->err));
-    Log(LG_PHYS2, ("%s", errmsg));
+    Log(LG_ERR|LG_PHYS2, ("%s", errmsg));
     (*ch->linfo.result)(ch->linfo.cookie, errmsg, 0);
     PptpCtrlKillChan(ch, "remote outgoing call failed");
     return;
@@ -2266,7 +2266,7 @@
   if ((ch = PptpCtrlGetChan(c, PPTP_CHAN_ST_WAIT_CONNECT, FALSE, TRUE,
       req->bearType, 0, 0, INT_MAX,
       callingNum, calledNum, subAddress)) == NULL) {
-    Log(LG_PHYS2, ("pptp%d: no free channels for incoming call", c->id));
+    Log(LG_ERR|LG_PHYS2, ("pptp%d: no free channels for incoming call", c->id));
     reply.result = PPTP_ICR_RESL_ERR;
     reply.err = PPTP_ERROR_NO_RESOURCE;
     goto done;
@@ -2325,7 +2325,7 @@
       "pptp%d-%d: peer denied incoming call: res=%s err=%s",
       c->id, ch->id, PPTP_ICR_RESL_CODE(reply->result),
       PPTP_ERROR_CODE(reply->err));
-    Log(LG_PHYS2, ("%s", errmsg));
+    Log(LG_ERR|LG_PHYS2, ("%s", errmsg));
     (*ch->linfo.result)(ch->linfo.cookie, errmsg, 0);
     PptpCtrlKillChan(ch, "peer denied incoming call");
     return;
@@ -2369,7 +2369,7 @@
   PptpCtrl			const c = ch->ctrl;
 
   if (PPTP_CHAN_IS_PNS(ch)) {
-    Log(LG_PHYS2, ("pptp%d-%d: got %s, but we are PNS for this call",
+    Log(LG_ERR|LG_PHYS2, ("pptp%d-%d: got %s, but we are PNS for this call",
       c->id, ch->id, gPptpMsgInfo[PPTP_CallClearRequest].name));
     PptpCtrlKillCtrl(c);
     return;
